# all files / ol/render/ renderfeature.js

100% Statements 31/31
77.78% Branches 7/9
100% Functions 9/9
100% Lines 31/31

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    1591×

    1×
    1×
    1×

    1×

    2×

    2×

    2×

    2×

    2×

    2×

    1×
    1×

    1×
    1×

    1×
    3×
    2×

    3×

    1×

    1×

    1×
    2×

    1×
    1×

    1×

    1×
    1×

    1×

    1×
    1×

     goog.provide('ol.render.Feature');

    goog.require('goog.asserts');
    goog.require('ol.extent');
    goog.require('ol.geom.GeometryType');

    /**
     * Lightweight, read-only, {@link ol.Feature} and {@link ol.geom.Geometry} like
     * structure, optimized for rendering and styling. Geometry access through the
     * API is limited to getting the type and extent of the geometry.
     *
     * @constructor
     * @param {ol.geom.GeometryType} type Geometry type.
     * @param {Array.<number>} flatCoordinates Flat coordinates. These always need
     *     to be right-handed for polygons.
     * @param {Array.<number>|Array.<Array.<number>>} ends Ends or Endss.
     * @param {Object.<string, *>} properties Properties.
     */
    ol.render.Feature = function(type, flatCoordinates, ends, properties) {

      /**
       * @private
       * @type {ol.Extent|undefined}
       */
      this.extent_;

      goog.asserts.assert(type === ol.geom.GeometryType.POINT ||
          type === ol.geom.GeometryType.MULTI_POINT ||
          type === ol.geom.GeometryType.LINE_STRING ||
          type === ol.geom.GeometryType.MULTI_LINE_STRING ||
          type === ol.geom.GeometryType.POLYGON,
          'Need a Point, MultiPoint, LineString, MultiLineString or Polygon type');

      /**
       * @private
       * @type {ol.geom.GeometryType}
       */
      this.type_ = type;

      /**
       * @private
       * @type {Array.<number>}
       */
      this.flatCoordinates_ = flatCoordinates;

      /**
       * @private
       * @type {Array.<number>|Array.<Array.<number>>}
       */
      this.ends_ = ends;

      /**
       * @private
       * @type {Object.<string, *>}
       */
      this.properties_ = properties;

    };

    /**
     * Get a feature property by its key.
     * @param {string} key Key
     * @return {*} Value for the requested key.
     * @api
     */
    ol.render.Feature.prototype.get = function(key) {
      return this.properties_[key];
    };

    /**
     * @return {Array.<number>|Array.<Array.<number>>} Ends or endss.
     */
    ol.render.Feature.prototype.getEnds = function() {
      return this.ends_;
    };

    /**
     * Get the extent of this feature's geometry.
     * @return {ol.Extent} Extent.
     * @api
     */
    ol.render.Feature.prototype.getExtent = function() {
      if (!this.extent_) {
        this.extent_ = this.type_ === ol.geom.GeometryType.POINT ?
            ol.extent.createOrUpdateFromCoordinate(this.flatCoordinates_) :
            ol.extent.createOrUpdateFromFlatCoordinates(
                this.flatCoordinates_, 0, this.flatCoordinates_.length, 2);

      }
      return this.extent_;
    };

    /**
     * @return {Array.<number>} Flat coordinates.
     */
    ol.render.Feature.prototype.getFlatCoordinates =
        ol.render.Feature.prototype.getOrientedFlatCoordinates = function() {
      return this.flatCoordinates_;
    };

    /**
     * Get the feature for working with its geometry.
     * @return {ol.render.Feature} Feature.
     * @api
     */
    ol.render.Feature.prototype.getGeometry = function() {
      return this;
    };

    /**
     * Get the feature properties.
     * @return {Object.<string, *>} Feature properties.
     * @api
     */
    ol.render.Feature.prototype.getProperties = function() {
      return this.properties_;
    };

    /**
     * Get the feature for working with its geometry.
     * @return {ol.render.Feature} Feature.
     */
    ol.render.Feature.prototype.getSimplifiedGeometry =
        ol.render.Feature.prototype.getGeometry;

    /**
     * @return {number} Stride.
     */
    ol.render.Feature.prototype.getStride = function() {
      return 2;
    };

    /**
     * @return {undefined}
     */
    ol.render.Feature.prototype.getStyleFunction = ol.nullFunction;

    /**
     * Get the type of this feature's geometry.
     * @return {ol.geom.GeometryType} Geometry type.
     * @api
     */
    ol.render.Feature.prototype.getType = function() {
      return this.type_;
    };